git-write-tree should not crash if prefix does not exist
[git/dscho.git] / git-mergetool.sh
blob47a80553ad3283c49cae0fbffcf444b93c8e34b7
1 #!/bin/sh
3 # This program resolves merge conflicts in git
5 # Copyright (c) 2006 Theodore Y. Ts'o
7 # This file is licensed under the GPL v2, or a later version
8 # at the discretion of Junio C Hamano.
11 USAGE='[--tool=tool] [file to merge] ...'
12 SUBDIRECTORY_OK=Yes
13 . git-sh-setup
14 require_work_tree
16 # Returns true if the mode reflects a symlink
17 is_symlink () {
18 test "$1" = 120000
21 local_present () {
22 test -n "$local_mode"
25 remote_present () {
26 test -n "$remote_mode"
29 base_present () {
30 test -n "$base_mode"
33 cleanup_temp_files () {
34 if test "$1" = --save-backup ; then
35 mv -- "$BACKUP" "$path.orig"
36 rm -f -- "$LOCAL" "$REMOTE" "$BASE"
37 else
38 rm -f -- "$LOCAL" "$REMOTE" "$BASE" "$BACKUP"
42 describe_file () {
43 mode="$1"
44 branch="$2"
45 file="$3"
47 printf " {%s}: " "$branch"
48 if test -z "$mode"; then
49 echo "deleted"
50 elif is_symlink "$mode" ; then
51 echo "a symbolic link -> '$(cat "$file")'"
52 else
53 if base_present; then
54 echo "modified"
55 else
56 echo "created"
62 resolve_symlink_merge () {
63 while true; do
64 printf "Use (l)ocal or (r)emote, or (a)bort? "
65 read ans
66 case "$ans" in
67 [lL]*)
68 git checkout-index -f --stage=2 -- "$path"
69 git add -- "$path"
70 cleanup_temp_files --save-backup
71 return
73 [rR]*)
74 git checkout-index -f --stage=3 -- "$path"
75 git add -- "$path"
76 cleanup_temp_files --save-backup
77 return
79 [aA]*)
80 exit 1
82 esac
83 done
86 resolve_deleted_merge () {
87 while true; do
88 if base_present; then
89 printf "Use (m)odified or (d)eleted file, or (a)bort? "
90 else
91 printf "Use (c)reated or (d)eleted file, or (a)bort? "
93 read ans
94 case "$ans" in
95 [mMcC]*)
96 git add -- "$path"
97 cleanup_temp_files --save-backup
98 return
100 [dD]*)
101 git rm -- "$path" > /dev/null
102 cleanup_temp_files
103 return
105 [aA]*)
106 exit 1
108 esac
109 done
112 check_unchanged () {
113 if test "$path" -nt "$BACKUP" ; then
114 status=0;
115 else
116 while true; do
117 echo "$path seems unchanged."
118 printf "Was the merge successful? [y/n] "
119 read answer < /dev/tty
120 case "$answer" in
121 y*|Y*) status=0; break ;;
122 n*|N*) status=1; break ;;
123 esac
124 done
128 save_backup () {
129 if test "$status" -eq 0; then
130 mv -- "$BACKUP" "$path.orig"
134 remove_backup () {
135 if test "$status" -eq 0; then
136 rm "$BACKUP"
140 merge_file () {
141 path="$1"
143 f=`git ls-files -u -- "$path"`
144 if test -z "$f" ; then
145 if test ! -f "$path" ; then
146 echo "$path: file not found"
147 else
148 echo "$path: file does not need merging"
150 exit 1
153 BACKUP="$path.BACKUP.$$"
154 LOCAL="$path.LOCAL.$$"
155 REMOTE="$path.REMOTE.$$"
156 BASE="$path.BASE.$$"
158 mv -- "$path" "$BACKUP"
159 cp -- "$BACKUP" "$path"
161 base_mode=`git ls-files -u -- "$path" | awk '{if ($3==1) print $1;}'`
162 local_mode=`git ls-files -u -- "$path" | awk '{if ($3==2) print $1;}'`
163 remote_mode=`git ls-files -u -- "$path" | awk '{if ($3==3) print $1;}'`
165 base_present && git cat-file blob ":1:$path" > "$BASE" 2>/dev/null
166 local_present && git cat-file blob ":2:$path" > "$LOCAL" 2>/dev/null
167 remote_present && git cat-file blob ":3:$path" > "$REMOTE" 2>/dev/null
169 if test -z "$local_mode" -o -z "$remote_mode"; then
170 echo "Deleted merge conflict for '$path':"
171 describe_file "$local_mode" "local" "$LOCAL"
172 describe_file "$remote_mode" "remote" "$REMOTE"
173 resolve_deleted_merge
174 return
177 if is_symlink "$local_mode" || is_symlink "$remote_mode"; then
178 echo "Symbolic link merge conflict for '$path':"
179 describe_file "$local_mode" "local" "$LOCAL"
180 describe_file "$remote_mode" "remote" "$REMOTE"
181 resolve_symlink_merge
182 return
185 echo "Normal merge conflict for '$path':"
186 describe_file "$local_mode" "local" "$LOCAL"
187 describe_file "$remote_mode" "remote" "$REMOTE"
188 printf "Hit return to start merge resolution tool (%s): " "$merge_tool"
189 read ans
191 case "$merge_tool" in
192 kdiff3)
193 if base_present ; then
194 (kdiff3 --auto --L1 "$path (Base)" -L2 "$path (Local)" --L3 "$path (Remote)" \
195 -o "$path" -- "$BASE" "$LOCAL" "$REMOTE" > /dev/null 2>&1)
196 else
197 (kdiff3 --auto -L1 "$path (Local)" --L2 "$path (Remote)" \
198 -o "$path" -- "$LOCAL" "$REMOTE" > /dev/null 2>&1)
200 status=$?
201 remove_backup
203 tkdiff)
204 if base_present ; then
205 tkdiff -a "$BASE" -o "$path" -- "$LOCAL" "$REMOTE"
206 else
207 tkdiff -o "$path" -- "$LOCAL" "$REMOTE"
209 status=$?
210 save_backup
212 meld|vimdiff)
213 touch "$BACKUP"
214 $merge_tool -- "$LOCAL" "$path" "$REMOTE"
215 check_unchanged
216 save_backup
218 gvimdiff)
219 touch "$BACKUP"
220 gvimdiff -f -- "$LOCAL" "$path" "$REMOTE"
221 check_unchanged
222 save_backup
224 xxdiff)
225 touch "$BACKUP"
226 if base_present ; then
227 xxdiff -X --show-merged-pane \
228 -R 'Accel.SaveAsMerged: "Ctrl-S"' \
229 -R 'Accel.Search: "Ctrl+F"' \
230 -R 'Accel.SearchForward: "Ctrl-G"' \
231 --merged-file "$path" -- "$LOCAL" "$BASE" "$REMOTE"
232 else
233 xxdiff -X --show-merged-pane \
234 -R 'Accel.SaveAsMerged: "Ctrl-S"' \
235 -R 'Accel.Search: "Ctrl+F"' \
236 -R 'Accel.SearchForward: "Ctrl-G"' \
237 --merged-file "$path" -- "$LOCAL" "$REMOTE"
239 check_unchanged
240 save_backup
242 opendiff)
243 touch "$BACKUP"
244 if base_present; then
245 opendiff "$LOCAL" "$REMOTE" -ancestor "$BASE" -merge "$path" | cat
246 else
247 opendiff "$LOCAL" "$REMOTE" -merge "$path" | cat
249 check_unchanged
250 save_backup
252 emerge)
253 if base_present ; then
254 emacs -f emerge-files-with-ancestor-command "$LOCAL" "$REMOTE" "$BASE" "$path"
255 else
256 emacs -f emerge-files-command "$LOCAL" "$REMOTE" "$path"
258 status=$?
259 save_backup
261 esac
262 if test "$status" -ne 0; then
263 echo "merge of $path failed" 1>&2
264 mv -- "$BACKUP" "$path"
265 exit 1
267 git add -- "$path"
268 cleanup_temp_files
271 while case $# in 0) break ;; esac
273 case "$1" in
274 -t|--tool*)
275 case "$#,$1" in
276 *,*=*)
277 merge_tool=`expr "z$1" : 'z-[^=]*=\(.*\)'`
279 1,*)
280 usage ;;
282 merge_tool="$2"
283 shift ;;
284 esac
287 break
290 usage
293 break
295 esac
296 shift
297 done
299 if test -z "$merge_tool"; then
300 merge_tool=`git config merge.tool`
301 case "$merge_tool" in
302 kdiff3 | tkdiff | xxdiff | meld | opendiff | emerge | vimdiff | gvimdiff | "")
303 ;; # happy
305 echo >&2 "git config option merge.tool set to unknown tool: $merge_tool"
306 echo >&2 "Resetting to default..."
307 unset merge_tool
309 esac
312 if test -z "$merge_tool" ; then
313 if test -n "$DISPLAY"; then
314 merge_tool_candidates="kdiff3 tkdiff xxdiff meld gvimdiff"
315 if test -n "$GNOME_DESKTOP_SESSION_ID" ; then
316 merge_tool_candidates="meld $merge_tool_candidates"
318 if test "$KDE_FULL_SESSION" = "true"; then
319 merge_tool_candidates="kdiff3 $merge_tool_candidates"
322 if echo "${VISUAL:-$EDITOR}" | grep 'emacs' > /dev/null 2>&1; then
323 merge_tool_candidates="$merge_tool_candidates emerge"
325 if echo "${VISUAL:-$EDITOR}" | grep 'vim' > /dev/null 2>&1; then
326 merge_tool_candidates="$merge_tool_candidates vimdiff"
328 merge_tool_candidates="$merge_tool_candidates opendiff emerge vimdiff"
329 echo "merge tool candidates: $merge_tool_candidates"
330 for i in $merge_tool_candidates; do
331 if test $i = emerge ; then
332 cmd=emacs
333 else
334 cmd=$i
336 if type $cmd > /dev/null 2>&1; then
337 merge_tool=$i
338 break
340 done
341 if test -z "$merge_tool" ; then
342 echo "No available merge resolution programs available."
343 exit 1
347 case "$merge_tool" in
348 kdiff3|tkdiff|meld|xxdiff|vimdiff|gvimdiff|opendiff)
349 if ! type "$merge_tool" > /dev/null 2>&1; then
350 echo "The merge tool $merge_tool is not available"
351 exit 1
354 emerge)
355 if ! type "emacs" > /dev/null 2>&1; then
356 echo "Emacs is not available"
357 exit 1
361 echo "Unknown merge tool: $merge_tool"
362 exit 1
364 esac
366 if test $# -eq 0 ; then
367 files=`git ls-files -u | sed -e 's/^[^ ]* //' | sort -u`
368 if test -z "$files" ; then
369 echo "No files need merging"
370 exit 0
372 echo Merging the files: $files
373 git ls-files -u | sed -e 's/^[^ ]* //' | sort -u | while read i
375 printf "\n"
376 merge_file "$i" < /dev/tty > /dev/tty
377 done
378 else
379 while test $# -gt 0; do
380 printf "\n"
381 merge_file "$1"
382 shift
383 done
385 exit 0